/*
 * Copyright (c) 2016 Menny Even-Danan
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.anysoftkeyboard.devicespecific;

import android.annotation.TargetApi;
import android.view.inputmethod.InputMethodSubtype;

@TargetApi(24)
public class DeviceSpecificV24 extends DeviceSpecificV19 {
    @Override
    public String getApiLevel() {
        return "DeviceSpecificV24";
    }

    @Override
    protected InputMethodSubtype.InputMethodSubtypeBuilder buildAndFillSubtypeBuilder(
            String locale, CharSequence keyboardId) {
        // adding languageTag
        return super.buildAndFillSubtypeBuilder(locale, keyboardId).setLanguageTag(locale);
    }
}
